#!/bin/bash

echo 'This script is installing Strip 0.3 on your system'

# Install the sources
mkdir -p /usr/share/pyshared/strip
cp -r ./src /usr/share/pyshared/strip
cp -r ./ui /usr/share/pyshared/strip
chmod -R +rx /usr/share/pyshared/strip/src
chmod -R +rx /usr/share/pyshared/strip/ui

# Install the icons
cp ./icons/16/strip.svg /usr/share/icons/hicolor/16x16/apps
cp ./icons/24/strip.svg /usr/share/icons/hicolor/24x24/apps
cp ./icons/48/strip.svg /usr/share/icons/hicolor/48x48/apps
cp ./icons/64/strip.svg /usr/share/icons/hicolor/64x64/apps
cp ./icons/128/strip.svg /usr/share/icons/hicolor/128x128/apps
cp ./icons/48/strip.svg /usr/share/icons/hicolor/scalable/apps

# Install localisation
cp -r ./locale /usr/share

# Create the symbolic link
rm /usr/local/bin/strip-comicbook
ln -s /usr/share/pyshared/strip/src/strip.py /usr/local/bin/strip-comicbook

# Install desktop file
echo '#!/usr/bin/env xdg-open

[Desktop Entry]
Type=Application
Terminal=false
Exec=strip-comicbook
Categories=Application;Graphics;Viewer;
Name=Strip
Icon=/usr/share/icons/hicolor/scalable/apps/strip.svg'  > /usr/share/applications/strip-comicbook.desktop
chmod +rx /usr/share/applications/strip-comicbook.desktop

echo 'Strip 0.3 installed'
