#!/usr/bin/env python
# -*- coding: utf-8 -*-

import os
import gtk
#~ import Image

class Book(object):
    def __init__(self, path, image_types, archive_types):
        '''Create a book wich store the path to its pages and informations'''
        self.folder = ''
        self.page = []
        self.page_list = []
        self.length = 0
        
        if os.path.isdir(path):
            self.folder = path
            self.page_list = self.open_image_file(image_types)
        else:
            fileType = path.split(".")[-1]
            for type in image_types:
                if type == fileType:
                    self.folder = path[:len(path)-len(os.path.basename(path))]
                    self.page_list = self.open_image_file(image_types)
            for type in archive_types:
                if type == fileType:
                    self.open_archive_file(path)
        self.length = len(self.page_list)
        self.page = self.create_pages(self.folder, self.page_list)
        
    def open_image_file(self, image_types):
        folder_content = os.listdir(self.folder)
        page_list = []
        for file in folder_content:
            fileType = file.split(".")[-1]
            for type in  image_types:
                if type == fileType:
                    page_list.append(file)
        return sorted(page_list)
    
    def open_archive_file(self, path):
        print(path + ' is an archive')
    
    def create_pages(self, folder, page_list):
        pages = []
        for file in page_list:
            pages.append(Page(str(self.folder + '/' + file)))
        return pages
    
class Page(object):
    def __init__(self, path):
        self.path = path
    
    def get_image(self):
        image = gtk.Image()
        image.set_from_file(self.path)
        return image
