#!/usr/bin/env python
# -*- coding: utf-8 -*-
#
#       Strip
#       
#       Copyright 2011 Kekun <kekun.plazas@laposte.net>
#       
#       This program is free software; you can redistribute it and/or modify
#       it under the terms of the GNU General Public License as published by
#       the Free Software Foundation; either version 3 of the License, or
#       (at your option) any later version.
#       
#       This program is distributed in the hope that it will be useful,
#       but WITHOUT ANY WARRANTY; without even the implied warranty of
#       MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#       GNU General Public License for more details.
#       
#       You should have received a copy of the GNU General Public License
#       along with this program; if not, write to the Free Software
#       Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
#       MA 02110-1301, USA.



# #      TO DO
#
#       Add document properties and informations
#       Add a database to remember informations on books (last page used, manga mode...)
#       Doit tester différents algos de redimensionnement



import os
import pygtk
pygtk.require("2.0")
import gtk
import gtk.glade

import modebutton
import book
import image
import preferences

APP = 'strip-comicbook'
DIR = '../locale'
if not os.path.exists('../locale'):
    DIR = '/usr/share/locale'
 
import locale
import gettext

#~ gettext.install(APP)
#~ locale.setlocale(locale.LC_ALL, '')
gettext.bindtextdomain(APP, DIR)
gettext.textdomain(APP)
locale.bindtextdomain(APP, DIR)
locale.textdomain(APP)
#~ for module in (gettext, gtk.glade):
    #~ module.bindtextdomain(APP, DIR)
    #~ module.textdomain(APP)
_ = gettext.gettext

class UI(object):
    def __init__(self):
        self.install_dir = '../'
        if not os.path.exists(self.install_dir + 'ui/strip-comicbook.glade'):
            self.install_dir = '/usr/share/pyshared/strip/'
        
        self.preferences = preferences.Preferences()
                
        self.call_main_window()
                
        self.mainWindow_size = self.get_layout_size()
        self.layout.modify_bg(gtk.STATE_NORMAL, gtk.gdk.Color(4095, 4095, 4095))
        
        self.book = book.Book('', self.preferences.imageTypes, self.preferences.archiveTypes)
        self.last_page = 0
        self.actual_page = 0
        self.scrool_offset = 0
        self.scrool_speed = 0.1
        self.refresh()
    
    def call_main_window(self):
        # Import the UI
        window = gtk.Builder()
        window.add_from_file(self.install_dir + 'ui/strip-comicbook.glade')
        self.mainWindow = window.get_object('mainWindow')
        self.toolbars = window.get_object('toolbars')
        self.modeToolbar = window.get_object('modeToolbar')
        self.pagechangerToolbar = window.get_object('pagechangerToolbar')
        self.appToolbar = window.get_object('appToolbar')
        
        self.preferencesWindow = window.get_object('preferencesWindow')
        self.aboutWindow = window.get_object('aboutWindow')
        self.filechooserWindow = window.get_object('filechooserWindow')
        self.filter = window.get_object('filter')
        self.filter.set_name("Images")
        for type in self.preferences.imageTypes:
            self.filter.add_pattern("*." + type)
        for type in self.preferences.archiveTypes:
            self.filter.add_pattern("*." + type)
        #~ self.filter.add_mime_type("image/png")
        #~ self.filter.add_mime_type("image/jpeg")
        #~ self.filter.add_mime_type("image/gif")
        #~ self.filter.add_pattern("*.*")
        
        # Import tools
        self.pageLeftLabel = window.get_object('pageLeftLabel')
        self.pageMiddleLabel = window.get_object('pageMiddleLabel')
        self.pageRightLabel = window.get_object('pageRightLabel')
        self.pageLeft = window.get_object('pageLeft')
        self.pageRight = window.get_object('pageRight')
        self.pageAdjustment = window.get_object('pageAdjustment')
        
        self.pageScroolbar = window.get_object('pageScroolbar')
        self.pageScroolbar.set_inverted(self.preferences.mangaMode)
        self.lensButton = window.get_object('lensButton')
        self.bookmarkButton = window.get_object('bookmarkButton')
        self.menuButton = window.get_object('menuButton')
        
        # Import menu
        self.menu = window.get_object('menu')
        self.fullscreen = window.get_object('fullscreen')
        self.rotate_clockwise = window.get_object('rotate_clockwise')
        self.rotate_counterclockwise = window.get_object('rotate_counterclockwise')
        self.leave_fullscreen = window.get_object('leave_fullscreen')
        self.shadow_check = window.get_object('shadow_check')
        self.shadow_check.set_active(self.preferences.shadow)
        self.clockwise_check = window.get_object('clockwise_check')
        self.clockwise_check.set_active(self.preferences.clockwise)
        
        # Import layout and images
        self.layout = window.get_object('layout')
        self.imageLeft = window.get_object('imageLeft')
        self.imageRight = window.get_object('imageRight')
        self.shadowLeft = window.get_object('shadowLeft')
        self.shadowRight = window.get_object('shadowRight')
        
        self.vbox_welcome = window.get_object('vbox_welcome')
                
        window.connect_signals(self)
        
        # Mode.button
        self.view_mode = modebutton.ModeButton()
        self.view_mode.show()
        self.view_mode_toolitem = gtk.ToolItem()
        self.view_mode_toolitem.set_border_width(4)
        self.view_mode_toolitem.show()
        self.view_mode_toolitem.add(self.view_mode)
        self.modeToolbar.insert(self.view_mode_toolitem, 0)
        double_page = gtk.Image()
        double_page.set_from_file(self.install_dir + 'ui/view-mode-double.svg')
        double_page.show()
        self.view_mode.append(double_page)
        simple_page = gtk.Image()
        simple_page.set_from_file(self.install_dir + 'ui/view-mode-simple.svg')
        self.view_mode.append(simple_page)
        simple_page.show()
        fit_width = gtk.Image()
        fit_width.set_from_file(self.install_dir + 'ui/view-adjust-width.svg')
        self.view_mode.append(fit_width)
        fit_width.show()
        
        self.view_mode.connect('button_press_event', self.on_view_mode_button_press_event)
        self.view_mode.set_selected(self.preferences.view_mode)
        
        self.manga_mode = modebutton.ModeButton()
        self.manga_mode.show()
        self.manga_mode_toolitem = gtk.ToolItem()
        self.manga_mode_toolitem.set_border_width(4)
        self.manga_mode_toolitem.show()
        self.manga_mode_toolitem.add(self.manga_mode)
        self.modeToolbar.insert(self.manga_mode_toolitem, 0)
        manga = gtk.Image()
        manga.set_from_file(self.install_dir + 'ui/view-read-manga.svg')
        manga.show()
        self.manga_mode.append(manga)
        comic = gtk.Image()
        comic.set_from_file(self.install_dir + 'ui/view-read-comic.svg')
        self.manga_mode.append(comic)
        comic.show()
        
        self.manga_mode.connect('button_press_event', self.on_manga_mode_button_press_event)
        self.manga_mode.set_selected(not self.preferences.mangaMode)
        
        
        # Hide not yet used elements
        self.lensButton.set_sensitive(False)
        self.bookmarkButton.set_sensitive(False)        
        properties = window.get_object('properties')
        comments = window.get_object('comments')
        comments.set_sensitive(False)
        shadow_check = window.get_object('shadow_check')
        shadow_check.hide()
        enhance = window.get_object('enhance')
        enhance.set_sensitive(False)
        enhance.hide()
        preferences = window.get_object('preferences')
        preferences.hide()
        properties.set_sensitive(False)
        properties.hide()
        welcome_last = window.get_object('welcome_last')
        welcome_last.set_sensitive(os.path.exists(self.preferences.last_file))
        
    
    def on_manga_mode_button_press_event(self, widget, event):
        '''Set the manga mode (reverse page display order and handeling)'''
        if widget.get_hovered() == 0:
            self.preferences.mangaMode = True
        elif widget.get_hovered() == 1:
            self.preferences.mangaMode = False
        self.pageScroolbar.set_inverted(self.preferences.mangaMode)
        self.refresh()
    
    def on_view_mode_button_press_event(self, widget, event):
        self.preferences.view_mode = widget.get_hovered()
        self.refresh()
    
    def on_mainWindow_destroy(self, widget):
        self.quit()
    
    def quit(self):
        '''Quit the application'''
        self.preferences.last_page = self.actual_page
        self.preferences.save()
        print('Bye')
        gtk.main_quit()
    
    def on_mainWindow_key_press_event(self, widget, event):
        key = gtk.gdk.keyval_name(event.keyval)
        try:
            self.Control_L
        except:
            self.Control_L = False
        if key == 'Control_L':
            self.Control_L = True
        if key == 'q' and self.Control_L == True:
            self.quit()
        if key == 'F11':
            self.on_fullscreen_activate(widget)
        if key == 'r':
            self.on_rotate_clockwise_activate(widget)
        if key == 'space':
            self.pageNext()
        if key == 'BackSpace':
            self.pagePrevious()
        if key == 'Home':
            self.pageAdjustment.set_value(self.pageAdjustment.get_lower())
        if key == 'End':
            self.pageAdjustment.set_value(self.pageAdjustment.get_upper())
        if key == 'Left':
            self.on_pageLeft_clicked(widget)
        if key == 'Right':
            self.on_pageRight_clicked(widget)
        if key == 'Up' and self.preferences.view_mode == 2:
            self.move_up()
        if key == 'Down' and self.preferences.view_mode == 2:
            self.move_down()
    
    def on_mainWindow_key_release_event(self, widget, event):
        key = gtk.gdk.keyval_name(event.keyval)
        if key == 'Control_L':
            self.Control_L = False            



    #### Toolbar    
    def on_pageLeft_clicked(self, widget):
        '''Move to the next left pages of the book'''
        if self.preferences.mangaMode:
            self.pageNext()
        else:
            self.pagePrevious()
    
    def on_pageRight_clicked(self, widget):
        '''Move to the next right pages of the book'''
        if self.preferences.mangaMode:
            self.pagePrevious()
        else:
            self.pageNext()
    
    def on_pageAdjustment_value_changed(self, widget):
        '''Change the pages when the horizontal cursor is used'''
        # Redraw only on new integer values
        if int(self.pageAdjustment.get_value()) != self.actual_page:
            self.actual_page = int(self.pageAdjustment.get_value())
            self.refresh()
    
    def on_layout_button_press_event(self, widget, event):
        '''Change the pages depending of where the layout is clicked'''
        if event.button == 1:
            if not self.preferences.rotated:
                # Click on the left side
                if self.layout.get_pointer()[0] < int(self.get_layout_size()[0] / 2):
                     self.on_pageLeft_clicked(widget)
                # Click on the right side
                else:
                    self.on_pageRight_clicked(widget)
            if self.preferences.rotated:
                # Click on the top side
                if self.layout.get_pointer()[1] < int(self.get_layout_size()[1] / 2):
                    if self.preferences.clockwise:
                        self.on_pageLeft_clicked(widget)
                    else:
                        self.on_pageRight_clicked(widget)
                # Click on the bottom side      
                else:
                    if not self.preferences.clockwise:
                        self.on_pageLeft_clicked(widget)
                    else:
                        self.on_pageRight_clicked(widget)
        if event.button == 2:
            self.on_fullscreen_activate(widget)
        if event.button == 3 and self.preferences.is_fullscreen:
            self.menu.popup(None, None, None, 1, gtk.get_current_event_time())
            self.menu.select_first(True)
    
    def on_lensButton_clicked(self, widget):
        print('lens')
    
    def on_bookmarkButton_clicked(self, widget):
        print('bookmark')
    
    def on_menuButton_clicked(self, widget):
        '''Display the app menu when the menu button is clicked'''
        if not self.menu.get_attach_widget():
            self.menu.attach_to_widget(widget, None)
        self.menu.popup(None, None, self.menu_position, 1, gtk.get_current_event_time())
        self.menu.select_first(True)
    
    def on_menu_deactivate(self, widget):
        '''Set the menu button back to normal when the menu is closed'''
        self.menuButton.set_active(False)
    
    #### Menu
    def on_open_activate(self, widget):
        '''Display the Open dialog to select a book to read'''
        self.filechooserWindow.run()
        self.filechooserWindow.hide()
        self.open_file(self.filechooserWindow.get_filename())
    
    def on_properties_activate(self, widget):
        print('properties')
    
    def on_comments_activate(self, widget):
        print('comments')
    
    def on_fullscreen_activate(self, widget):
        if not self.preferences.is_fullscreen and self.enable_fullscreen:
            self.preferences.is_fullscreen = True
            self.fullscreen.hide()
            self.leave_fullscreen.show()
            self.toolbars.hide()
            self.mainWindow.fullscreen()
        else:
            self.preferences.is_fullscreen = False
            self.fullscreen.show()
            self.leave_fullscreen.hide()
            self.toolbars.show()
            self.mainWindow.unfullscreen()
        
    def on_leave_fullscreen_activate(self, widget):
        self.on_fullscreen_activate(widget)
    
    def on_rotate_clockwise_activate(self, widget):
        '''Rotate the pages on a choosen side or make them back to normal'''
        if self.preferences.rotated:
            self.preferences.rotated = False
        else:
            self.preferences.rotated = True
        self.refresh()
    
    def on_rotate_counterclockwise_activate(self, widget):
        self.on_rotate_clockwise_activate(widget)
    
    def on_enhance_activate(self, widget):
        print('enhance')
    
    def on_about_activate(self, widget):
        '''Display the About dialog'''
        self.aboutWindow.run()
        self.aboutWindow.hide()
        
    def on_preferences_activate(self, widget):
        '''Display the preferences window'''
        self.call_preferences_window()
        
    def on_preferencesWindow_destroy(self, widget):
        self.refresh()
    
    def menu_position(self, menu, data=None):
        '''Return the position of the menu under the clicked widget'''
        widget = menu.get_attach_widget()
        allocation = widget.get_allocation()
        window_pos = widget.window.get_position()
        x = window_pos[0] + allocation.x
        y = window_pos[1] + allocation.y + allocation.height
        return (x, y, True)
    
    #### Preferences
    def on_shadow_check_toggled(self, widget):
        self.preferences.shadow = False
        if self.shadow_check.get_active():
            self.preferences.shadow = True
        self.refresh()
    
    def on_clockwise_check_toggled(self, widget):
        self.preferences.clockwise = False
        if self.clockwise_check.get_active():
            self.preferences.clockwise = True
        self.refresh()
    
    #### Other methods
    def on_welcome_open_clicked(self, widget):
        self.on_open_activate(widget)
    
    def on_welcome_last_clicked(self, widget):
        self.open_file(self.preferences.last_file)
    
    def open_file(self, path):
        '''Open the folder of the image or the archive given in path'''
        if os.path.exists(path):
            self.actual_page = 1
            self.book = book.Book(path, self.preferences.imageTypes, self.preferences.archiveTypes)
            if self.book.length > 0:
                self.preferences.last_file = path
                self.actual_page = self.preferences.last_page
            self.pageAdjustment.set_lower(1)
            self.pageAdjustment.set_upper(self.book.length + 1)
            self.refresh()
        
    def on_mainWindow_check_resize(self, widget):
        '''Redraw the pages if the size of the layout changed'''
        if self.mainWindow_size != self.get_layout_size():
            self.mainWindow_size = self.get_layout_size()
            self.refresh()
    
    def on_pageScroolbar_focus_in_event(self, widget, event):
        '''Remove the focus from the cursor'''
        self.layout.grab_focus()
    
    def on_layout_scroll_event(self, widget, event):
        if event.direction == gtk.gdk.SCROLL_UP and self.preferences.view_mode == 2:
            self.move_up()
        elif event.direction == gtk.gdk.SCROLL_DOWN and self.preferences.view_mode == 2:
            self.move_down()
                
    def move_up(self):
        self.scrool_offset += self.scrool_speed
        self.move_page(self.get_layout_size(), self.imageRight.size_request(), False, self.imageRight)
    
    def move_down(self):
        self.scrool_offset -= self.scrool_speed
        self.move_page(self.get_layout_size(), self.imageRight.size_request(), False, self.imageRight)
    
    def pageNext(self):
        '''Go forward in the book'''
        if self.book.length != 0:
            if self.preferences.view_mode == 0:
                self.actual_page = int(self.actual_page /2) * 2 + 2
            else:
                self.actual_page += 1
            self.check_page()
            self.refresh()
    
    def pagePrevious(self):
        '''Go backward in the book'''
        if self.book.length != 0:
            if self.preferences.view_mode == 0:
                self.actual_page = int(self.actual_page /2) * 2 - 2
            else:
                self.actual_page -= 1
            self.check_page()
            self.refresh()
    
    def get_layout_size(self):
        '''Get the size of the layout'''
        heigth, width = self.mainWindow.get_size()
        if not self.preferences.is_fullscreen:
            width -= self.appToolbar.size_request()[1]
        return heigth, width
    
    def check_page(self):
        if self.actual_page < 1:
            self.actual_page = 1
        if self.actual_page > self.book.length:
            self.actual_page = self.book.length
        if int(self.pageAdjustment.get_value()) != self.actual_page:
            self.pageAdjustment.set_value(self.actual_page)
    
    def refresh(self):
        '''Refresh the main window'''
        #~ print(int(self.pageAdjustment.get_lower()), self.actual_page, int(self.pageAdjustment.get_upper()), self.book.length)
                
        if self.last_page != self.actual_page:
            self.scrool_offset = 0
            self.last_page = self.actual_page
        
        if self.preferences.view_mode != 2:
            self.scrool_offset = 0
        
        # Test if a book is loaded or not
        try:
            if self.book.length > 0:
                self.layout.show()
                self.vbox_welcome.hide()
                self.enable_fullscreen = True
                self.fullscreen.set_sensitive(True)
            else:
                self.layout.hide()
                self.vbox_welcome.show()
                self.enable_fullscreen = False
                self.fullscreen.set_sensitive(False)
                
        except:
            self.layout.hide()
            self.vbox_welcome.show()
            self.enable_fullscreen = False
            self.fullscreen.set_sensitive(False)
        if self.actual_page < self.book.length:
            self.pageRight.set_sensitive(True)
        else:
            self.pageRight.set_sensitive(False)
        if self.actual_page > 1:
            self.pageLeft.set_sensitive(True)
        else:
            self.pageLeft.set_sensitive(False)
        if self.book.length != 0:
            self.pageScroolbar.set_sensitive(True)
        else:
            self.pageScroolbar.set_sensitive(False)
        
        # Set the direction of the rotation icon
        if (self.preferences.rotated and self.preferences.clockwise) or (not self.preferences.rotated and not self.preferences.clockwise):
            self.rotate_clockwise.hide()
            self.rotate_counterclockwise.show()
        else:
            self.rotate_clockwise.show()
            self.rotate_counterclockwise.hide()
        
        # Define the middle of the layout
        page_layout = int(self.get_layout_size()[0] / 2), self.get_layout_size()[1]
                
        if self.preferences.view_mode == 0:
            self.pageMiddleLabel.set_text('')
            if not self.preferences.mangaMode:
                if int(self.actual_page / 2) * 2 < 1:
                    self.hide_page(True)
                    self.pageLeftLabel.set_text('')
                else:
                    self.draw_page(True, self.book.page[int(self.actual_page / 2) * 2 - 1])
                    self.pageLeftLabel.set_text(str(int(self.actual_page / 2) * 2))
                if int(self.actual_page / 2) * 2 + 1 > self.book.length:
                    self.hide_page(False)
                    self.pageRightLabel.set_text('')
                else:
                    self.draw_page(False, self.book.page[int(self.actual_page / 2) * 2 - 0])
                    self.pageRightLabel.set_text(str(int(self.actual_page / 2) * 2 + 1))
            else:
                if int(self.actual_page / 2) * 2 - 1 < 0:
                    self.hide_page(False)
                    self.pageRightLabel.set_text('')
                else:
                    self.draw_page(False, self.book.page[int(self.actual_page / 2) * 2 - 1])
                    self.pageRightLabel.set_text(str(int(self.actual_page / 2) * 2 + 0))
                if int(self.actual_page / 2) * 2 + 1 > self.book.length:
                    self.hide_page(True)
                    self.pageLeftLabel.set_text('')
                else:
                    self.draw_page(True, self.book.page[int(self.actual_page / 2) * 2 - 0])
                    self.pageLeftLabel.set_text(str(int(self.actual_page / 2) * 2 + 1))
        else:
            self.pageLeftLabel.set_text('')
            self.pageRightLabel.set_text('')
            if self.book.length > 0:
                self.pageMiddleLabel.set_text(str(self.actual_page))
            else:
                self.pageMiddleLabel.set_text('')
            self.hide_page(True)
            if self.book.length != 0:
                self.draw_page(False, self.book.page[self.actual_page - 1])
            self.pageLeftLabel.set_text('')
            self.pageRightLabel.set_text('')
            self.pageMiddleLabel.set_text(str(self.actual_page))
            
    def draw_page(self, is_left_page, page):
        if self.preferences.view_mode == 0:
            self.preferences.shadow = True
        else:
            self.preferences.shadow = False
        # Show the images of the page
        if is_left_page:
            self.imageLeft.show()
            current_page = self.imageLeft
            if self.preferences.shadow:
                self.shadowLeft.show()
                current_shadow = self.shadowLeft
            else:
                self.shadowLeft.hide()
        else:
            self.imageRight.show()
            current_page = self.imageRight
            if self.preferences.shadow:
                self.shadowRight.show()
                current_shadow = self.shadowRight
            else:
                self.shadowRight.hide()
        
        # Open the images
        image = page.get_image()
        size = image.size_request()
        if self.preferences.shadow:
            shadow = book.Page(self.install_dir + self.preferences.shadow_image_path)
            shadow = shadow.get_image()
        
        # Flip the shadow image if needed
        if (is_left_page and self.preferences.shadow) or (not self.preferences.view_mode == 0 and (self.actual_page - (not self.preferences.mangaMode)) % 2):
            flip = True
        else:
            flip = False
        
        # Calculate the size available for the page and the ratios
        if self.preferences.rotated:
            page_layout = self.get_layout_size()[0], int(self.get_layout_size()[1] / ((self.preferences.view_mode == 0) + 1))
            page_ratio = float(size[1])/float(size[0])
        else:
            page_layout = int(self.get_layout_size()[0] / ((self.preferences.view_mode == 0) + 1)), self.get_layout_size()[1]
            page_ratio = float(size[0])/float(size[1])
        layout_ratio = float(page_layout[0])/float(page_layout[1])
                
        # If the space reserved to the page is taller than the page
        if self.preferences.view_mode == 2:
            if self.preferences.rotated:
                size = (page_layout[1] * page_ratio, page_layout[1])
            else:
                size = (page_layout[0], page_layout[0] / page_ratio)
        else:
            if layout_ratio < page_ratio:
                size = (page_layout[0], int(float(page_layout[0]) * (1 / page_ratio)))
            # If the space reserved to the page is wider than the page (or have the same proportions)
            else:
                size = (int(float(page_layout[1]) * page_ratio), page_layout[1])
        
        # Set the angle in degrees
        if self.preferences.rotated:
            if self.preferences.clockwise:
                rotation_angle = 270
            else:
                rotation_angle = 90
        else:
            rotation_angle = 0
        
        # Rotate, resize, convert, set and place images
        self.set_image(image, page_layout, is_left_page, current_page, size, rotation_angle)
        if self.preferences.shadow:
            self.set_image(shadow, page_layout, is_left_page, current_shadow, size, rotation_angle, flip)
            
    def hide_page(self, is_left_page):
        '''Hide the images if there is no page to display'''
        if is_left_page:
            self.imageLeft.hide()
            if self.preferences.shadow:
                self.shadowLeft.hide()
        else:
            self.imageRight.hide()
            if self.preferences.shadow:
                self.shadowRight.hide()
    
    def set_image(self, im, page_layout, is_left_page, destination, size = (0, 0), rotation_angle = 0, flip = False):
        '''Make a PIL image into a pixbuf, resize and rotate it, then return it into a GTK image and set its position.'''
        im = im.get_pixbuf()
        im = image.resize_and_rotate(im, size, rotation_angle, flip)
        destination.set_from_pixbuf(im)
        self.move_page(page_layout, size, is_left_page, destination)
    
    def move_page(self, page_layout, size, is_left_page, image):
        '''Move the images to their correct position'''
        if self.preferences.view_mode == 0:
            offset = size[self.preferences.rotated] * is_left_page
            if not self.preferences.rotated:
                self.layout.move(image, page_layout[0] - offset, (page_layout[1] - size[1]) / 2)
            else:
                if self.preferences.clockwise:
                    self.layout.move(image, (page_layout[0] - size[0]) / 2, page_layout[1] - offset)
                else:
                    offset = size[self.preferences.rotated] * (not is_left_page)
                    self.layout.move(image, (page_layout[0] - size[0]) / 2, page_layout[1] - offset)
        elif self.preferences.view_mode == 1:
            offset = (size[0] + self.get_layout_size()[0]) / 2
            self.layout.move(image, page_layout[0] - offset, (page_layout[1] - size[1]) / 2)
        else:
            if int(size[not self.preferences.rotated] * self.scrool_offset) < page_layout[not self.preferences.rotated] - size[not self.preferences.rotated]:
                self.scrool_offset = (float(size[not self.preferences.rotated] - page_layout[not self.preferences.rotated]) / float(size[not self.preferences.rotated])) * -1.0
            if self.scrool_offset > 0:
                self.scrool_offset = 0
            if (self.preferences.rotated and page_layout[0] > size[0]) or (not self.preferences.rotated and page_layout[1] > size[1]):
                self.scrool_offset = 0
                offset = (size[0] + self.get_layout_size()[0]) / 2
                self.layout.move(image, page_layout[0] - offset, (page_layout[1] - size[1]) / 2)
            else:
                offset = self.scrool_offset
                if self.preferences.rotated:
                    if self.preferences.clockwise:
                        self.layout.move(image, page_layout[0] - size[0] - int(size[0] * offset), 0)
                    else:
                        self.layout.move(image, int(size[0] * offset), 0)
                else:
                    self.layout.move(image, 0, int(size[1] * offset))

if __name__ == '__main__':
    user_path = os.environ.get('HOME') + '/.strip-comicbook'
    if not os.path.exists(user_path):
        os.makedirs(user_path)
    ui = UI()
    gtk.main()
